题 在Python中手动引发(抛出)异常


如何在Python中引发异常,以便以后可以通过它捕获 except 块?


1524
2018-01-12 21:07


起源




答案:


如何在Python中手动抛出/引发异常?

使用最具特异性的Exception构造函数,该构造函数在语义上适合您的问题

在您的信息中具体说明,例如:

raise ValueError('A very specific bad thing happened.')

不要引发一般异常

避免引发通用异常。为了捕获它,您将必须捕获所有其他更具体的异常子类。

问题1:隐藏错误

raise Exception('I know Python!') # Don't! If you catch, likely to hide bugs.

例如:

def demo_bad_catch():
    try:
        raise ValueError('Represents a hidden bug, do not catch this')
        raise Exception('This is the exception you expect to handle')
    except Exception as error:
        print('Caught this error: ' + repr(error))

>>> demo_bad_catch()
Caught this error: ValueError('Represents a hidden bug, do not catch this',)

问题2:不会抓住

更具体的捕获量不会捕获一般异常:

def demo_no_catch():
    try:
        raise Exception('general exceptions not caught by specific handling')
    except ValueError as e:
        print('we will not catch exception: Exception')


>>> demo_no_catch()
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "<stdin>", line 3, in demo_no_catch
Exception: general exceptions not caught by specific handling

最佳实践: raise 声明

相反,使用最具特异性的Exception构造函数,它在语义上适合您的问题

raise ValueError('A very specific bad thing happened')

它还可以方便地将任意数量的参数传递给构造函数:

raise ValueError('A very specific bad thing happened', 'foo', 'bar', 'baz') 

这些参数由。访问 args Exception对象的属性。例如:

try:
    some_code_that_may_raise_our_value_error()
except ValueError as err:
    print(err.args)

版画

('message', 'foo', 'bar', 'baz')    

在Python 2.5中,实际的 message 属性已添加到BaseException,有利于鼓励用户子类化Exceptions并停止使用 args但是 的简介 message 并且args的原始弃用已被撤回

最佳实践: except 条款

例如,在except子句中,您可能希望记录发生特定类型的错误,然后重新引发。在保留堆栈跟踪的同时执行此操作的最佳方法是使用bare raise语句。例如:

logger = logging.getLogger(__name__)

try:
    do_something_in_app_that_breaks_easily()
except AppError as error:
    logger.error(error)
    raise                 # just this!
    # raise AppError      # Don't do this, you'll lose the stack trace!

不要修改你的错误...但如果你坚持。

您可以使用保留堆栈跟踪(和错误值) sys.exc_info()但是 这种方式更容易出错 和 Python 2和3之间存在兼容性问题,宁愿使用裸露 raise 再加注。

解释 - sys.exc_info() 返回类型,值和回溯。

type, value, traceback = sys.exc_info()

这是Python 2中的语法 - 注意这与Python 3不兼容:

    raise AppError, error, sys.exc_info()[2] # avoid this.
    # Equivalently, as error *is* the second object:
    raise sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]

如果您愿意,可以修改新加注的情况 - 例如为实例设置新的args:

def error():
    raise ValueError('oops!')

def catch_error_modify_message():
    try:
        error()
    except ValueError:
        error_type, error_instance, traceback = sys.exc_info()
        error_instance.args = (error_instance.args[0] + ' <modification>',)
        raise error_type, error_instance, traceback

我们在修改args时保留了整个回溯。请注意,这是 不是最佳做法 它是 无效的语法 在Python 3中(使兼容性更难以解决)。

>>> catch_error_modify_message()
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "<stdin>", line 3, in catch_error_modify_message
  File "<stdin>", line 2, in error
ValueError: oops! <modification>

Python 3

    raise error.with_traceback(sys.exc_info()[2])

再次:避免手动操纵回溯。它的 效率低下 而且更容易出错。如果你正在使用线程和 sys.exc_info 你甚至可能得到错误的追溯(特别是如果你正在使用控制流的异常处理 - 我个人倾向于避免。)

Python 3,异常链接

在Python 3中,您可以链接Exceptions,它可以保留回溯:

    raise RuntimeError('specific message') from error

意识到:

  • 这个  允许更改引发的错误类型,和
  • 这是  与Python 2兼容。

弃用方法:

这些可以轻松隐藏甚至进入生产代码。你想引发一个异常,并且这样做会引发异常, 但不是那个意图!

在Python 2中有效,但在Python 3中没有 如下:

raise ValueError, 'message' # Don't do this, it's deprecated!

只要 在许多旧版本的Python中有效 (2.4及更低版本),你仍然可以看到人们提高字符串:

raise 'message' # really really wrong. don't do this.

在所有现代版本中,这实际上会引发TypeError,因为您没有引发BaseException类型。如果您没有检查正确的例外情况,并且没有知道该问题的审阅者,则可能会投入生产。

示例用法

如果他们错误地使用了我的API,我会引发Exceptions警告消费者:

def api_func(foo):
    '''foo should be either 'baz' or 'bar'. returns something very useful.'''
    if foo not in _ALLOWED_ARGS:
        raise ValueError('{foo} wrong, use "baz" or "bar"'.format(foo=repr(foo)))

在apropos时创建自己的错误类型

“我想故意犯错误,以便它会进入除外”

您可以创建自己的错误类型,如果要指示应用程序的特定错误,只需将异常层次结构中的相应点子类化:

class MyAppLookupError(LookupError):
    '''raise this when there's a lookup error for my app'''

和用法:

if important_key not in resource_dict and not ok_to_be_missing:
    raise MyAppLookupError('resource is missing, and that is not ok.')

1898
2018-06-05 16:30



谢谢你,这正是我所需要的。光秃秃的 raise 是我需要能够在多个代码执行级别执行自定义错误调试而不破坏堆栈跟踪。 - CaffeineConnoisseur
这是一个很好的答案。但是我仍然使用很多2.7代码,而且我经常发现自己想要将信息添加到意外的异常中,比如输入文件位置或某些变量的值,但保留原始堆栈和异常。我可以记录它,但有时我不想记录它,例如如果父代码最终处理它。 raise sys.exc_info()[0], (sys.exc_info()[1], my_extra_info), sys.exc_info()[2] 似乎做了我想做的事情,我从来没有遇到过问题。但它感到hacky,而不是一个公认的做法。有没有更好的办法? - Michael Scheper
感谢恭维 - 但遗憾的是,没有更好的方法 - 不是在Python 2上。 - Aaron Hall♦
@brennanyoung在这种情况下,我认为提出一个SyntaxError可能会让人感到困惑 - 可能你应该引发一个自定义异常。我在这里解释一下: stackoverflow.com/a/26938914/541136 - Aaron Hall♦
请注意,完整引用是“所有内置的,非系统退出的异常都是从此类派生的。所有用户定义的异常也应该从此类派生。” - 这主要意味着你不应该使用4个不能派生的例外中的一个 Exception 作为您的父类 - 您可以将更具体的内容子类化,如果有意义则应该这样做。 - Aaron Hall♦


不要这样做。提高裸露 Exception 绝对是  正确的做法;看到 亚伦霍尔的出色答案 代替。

不能得到比这更多的pythonic:

raise Exception("I know python!")

看到 提高声明文件 对于python,如果你想了解更多信息。


540
2018-01-12 21:08



不谢谢!这消除了对捕获的内容的具体可能性。完全是错误的做法。看看Aaron Hall的优秀答案,而不是这个。这样的时候我希望我能给每个答案多一个downvote。 - Dawood ibn Kareem
@DavidWallace很可怕,这有很多赞成:( - Peter R
@PeterR同样糟糕的是它有如此少的downvotes。对任何人来说,阅读这个答案,不要这样做!正确答案是Aaron Hall的答案。 - Dawood ibn Kareem
我认为应该有更详细的解释为什么这是错误或如此糟糕。 - Charlie Parker
@CharlieParker有。这是第一部分 亚伦霍尔的回答。 - Dinei


对于常见的情况,您需要抛出异常以响应某些意外情况,并且您永远不打算捕获,而只是快速失败以使您能够从那里进行调试(如果它发生的话) - 最合乎逻辑的似乎是 AssertionError

if 0 < distance <= RADIUS:
    #Do something.
elif RADIUS < distance:
    #Do something.
else:
    raise AssertionError("Unexpected value of 'distance'!", distance)

29
2018-05-19 04:55



这是一个更好的案例 ValueError 比 AssertionError 因为断言没有问题(因为这里没有任何问题) - 问题在于值。如果你真的想要一个 AssertionError 在这种情况下,写 assert distance > 0, 'Distance must be positive'。但你不应该错误检查,因为可以关闭断言(python -O)。 - Two-Bit Alchemist
@ Two-BitAlchemist好点。当我编写上面的简单示例时,这个想法在简化中丢失了。在许多类似的情况下,它是与特定值无关的条件。相反,意思是“控制流不应该到达这里”。 - Evgeni Sergeev
可以关闭@ Two-BitAlchemist断言,是的,但是你不应该使用它们进行错误检查吗? - Evgeni Sergeev
这得看情况。我不会让这是我打算分发的程序中唯一的错误检查。另一方面,我可以为我的同事制作一个程序,并告诉他们如果他们运行它,他们自己承担风险 -O。 - Two-Bit Alchemist
@ Two-BitAlchemist对我来说,断言的作用本身并不是错误检查(这是测试的用途),但它们在代码中设置了某些错误无法通过的范围。因此,跟踪和隔离错误变得更容易,这将不可避免地发生。这只是很好的习惯,只需要很少的努力,而测试需要花费很多精力和大量的时间。 - Evgeni Sergeev


在Python3中,有4种不同的语法用于rasing异常:

1. raise exception 
2. raise exception (args) 
3. raise
4. raise exception (args) from original_exception

1.引发异常与2.引发异常(args)

如果你使用 raise exception (args)  提出异常然后 args 将在打印异常对象时打印 - 如下例所示。

  #raise exception (args)
    try:
        raise ValueError("I have raised an Exception")
    except ValueError as exp:
        print ("Error", exp)     # Output -> Error I have raised an Exception 



  #raise execption 
    try:
        raise ValueError
    except ValueError as exp:
        print ("Error", exp)     # Output -> Error 

3.raise

raise 没有任何参数的语句重新引发最后一个异常。 如果您需要在捕获异常后执行某些操作然后想要重新提升它,这将非常有用。但如果之前没有例外, raise 声明提出 TypeError 例外。

def somefunction():
    print("some cleaning")

a=10
b=0 
result=None

try:
    result=a/b
    print(result)

except Exception:            #Output ->
    somefunction()           #some cleaning
    raise                    #Traceback (most recent call last):
                             #File "python", line 8, in <module>
                             #ZeroDivisionError: division by zero

4.从original_exception中引发异常(args)

此语句用于创建异常链接,其中为响应另一个异常而引发的异常可以包含原始异常的详细信息 - 如下面的示例所示。

class MyCustomException(Exception):
pass

a=10
b=0 
reuslt=None
try:
    try:
        result=a/b

    except ZeroDivisionError as exp:
        print("ZeroDivisionError -- ",exp)
        raise MyCustomException("Zero Division ") from exp

except MyCustomException as exp:
        print("MyException",exp)
        print(exp.__cause__)

输出:

ZeroDivisionError --  division by zero
MyException Zero Division 
division by zero

23
2017-11-08 17:54





首先阅读现有的答案,这只是一个附录。

请注意,您可以使用或不使用参数引发异常。

例:

raise SystemExit

退出程序,但你可能想知道发生了什么。所以你可以使用它。

raise SystemExit("program exited")

这将在关闭程序之前将“程序退出”打印到stderr。


5
2018-03-29 11:59